module class_Circle
  implicit none
  private
  real :: pi = 3.1415926535897931d0 ! Class-wide private constant



  type, public :: Circle
   real :: radius
   contains
     procedure :: area  => circle_area
     procedure :: print => circle_print
  end type Circle

  public :: Circle_type, circle_type_area, circle_type_print

  type Circle_type
     real :: radius


  end type Circle_type
  
contains

!
!Note que alteramos os parmetros fictcios de type(Circle) para class(Circle).
! Podemos ento chamar as funes da classe de forma orientada a objetos 
! como a = c%area e chamar c%print, onde o tipo  passado 
! para o primeiro argumento das funes circle_area e circle_print 
! automaticamente. 
!
  function circle_area(this) result(area)
    class(Circle), intent(in) :: this
    real :: area
    area = pi * this%radius**2
  end function circle_area

  subroutine circle_print(this)
    class(Circle), intent(in) :: this
    real :: area
    area = this%area()  ! Call the type-bound function
    print *, 'Circle: r = ', this%radius, ' area = ', area
  end subroutine circle_print


  function circle_type_area(this) result(area)
    type(Circle_type), intent(in) :: this
    real :: area
    area = pi * this%radius**2
  end function circle_type_area

  subroutine circle_type_print(this)
    type(Circle_type), intent(in) :: this
    real :: area
    area = circle_type_area(this)  ! Call the circle_area function
    print *, 'Circle: r = ', this%radius, ' area = ', area
  end subroutine circle_type_print

end module class_Circle


program circle_test
  use class_Circle
  implicit none
  type(Circle_type) :: c_type     ! Declare a variable of type Circle.
  type(Circle) :: c     ! Declare a variable of type Circle.

  c = Circle(1.5)       ! Use the implicit constructor, radius = 1.5.
  call c%print()        ! Call the type-bound subroutine

  c_type = Circle_type(1.5)       ! Use the implicit constructor, radius = 1.5.
  call circle_type_print(c_type)  ! Call a class subroutine

end program circle_test
