import test
import sys
import numpy as np
import matplotlib.pyplot as plt

mm2 = test.input.input_sp(np.array(1.0,dtype=np.float32))
mm2 = test.input.input_sp(np.array(1.0,dtype=np.float64))
mm2 = test.input.input_dp(np.array(1.0,dtype=np.float32))
mm2 = test.input.input_dp(np.array(1.0,dtype=np.float64))

positions = [[0, 0, 0], [0, 0, 0], [0, 0, 0]]
velocities = [[0, 1, 2], [0, 3, 2], [0, 1, 3]]

# During execution, the message created an array from object is displayed, 
# because a copy of is made when passing multidimensional array to fortran subroutine.

test.input.push(positions, velocities, 0.1)
print(positions) # memory is not updated because we used C memory storage

print('    ')

positions = np.array(positions, dtype='f8', order='F')
test.input.push(positions, velocities, 0.1)
print(positions)  # the memory is updated

font1 = {'family':'serif','color':'blue','size':20}
font2 = {'family':'serif','color':'darkred','size':15}
plt.title("Sports Watch Data",fontdict = font1)
plt.plot(positions[0,:], linestyle = 'solid')
plt.plot(positions[1,:], linestyle = 'dotted')
plt.plot(positions[2,:], linestyle = 'dashed')
plt.ylabel("Position",fontdict = font2)
plt.show()


# Create plots with pre-defined labels.
a=np.arange(3)  # numpy array
a=(1,2,3)
fig, ax = plt.subplots()
plt.title("Sports Watch Data",fontdict = font1)
ax.plot(a, positions[0,:], 'k--', label='positions 1', linestyle = 'solid' , color = 'blue')
ax.plot(a, positions[1,:], 'k:' , label='positions 2', linestyle = 'dotted', color = 'orange')
ax.plot(a, positions[2,:], 'k'  , label='positions 3', linestyle = 'dashed', color = 'green')
plt.ylabel("Position",fontdict = font2)

legend = ax.legend(loc='upper center', shadow=True, fontsize='x-large')

# Put a nicer background color on the legend.
legend.get_frame().set_facecolor('C0')
plt.show()


print('    ')
a=[2,3,4]  # Python list
type(a)
test.input.euclidian_norm(a)
print(a)
print('    ')

a=np.arange(2,5)  # numpy array
type(a)
test.input.euclidian_norm(a)
print(a)

print(test.input.euclidian_norm.__doc__) # Documentation
#################################################


