module input

contains 

subroutine input_sp(val)
  use types
  use mod_aa
  real(sp), intent(in) :: val
  real(sp) :: x
  x = val
  write(*,*) x
  CALL aa()
end subroutine input_sp

subroutine input_dp(val)
  use types
  real(dp), intent(in) :: val
  real(dp) :: x
  x = val
  write(*,*) dp, val, x
end subroutine input_dp

!Let see how to pass numpy arrays to fortran subroutine.

subroutine push( positions, velocities, dt, n)
  integer, intent(in) :: n
  real(8), intent(in) :: dt
  real(8), dimension(n,3), intent(in) :: velocities
  real(8), dimension(n,3) :: positions
  do i = 1, n
    positions(i,:) = positions(i,:) + dt*velocities(i,:)
  end do
end subroutine push

subroutine euclidian_norm(a,c,n) 
  integer :: n 
  real(8),dimension(n),intent(in) :: a
  !f2py optional , depend(a) :: n=len(a)
  real(8),intent(out) :: c 
  real(8) :: sommec 
  integer :: i
  sommec = 0 
  do i=1,n
    sommec=sommec+a( i )*a( i ) 
  end do
  c = sqrt (sommec) 
end subroutine euclidian_norm


!directives
!
!    optional: The corresponding argument is moved to the end.
!
!    required: This is default. Use it to disable automatic optional setting.
!
!    intent(in | inout | out | hide) , intent(in) is the default.
!
!    intent(out) is implicitly translated to intent(out,hide) .
!
!    intent(copy) and intent(overwrite) control changes for input arguments.
!
!    check performs some assertions, it is often automatically generated.
!
!    depend: f2py detects cyclic dependencies.
!
!    allocatable, parameter
!
!    intent(callback), external: for function as arguments.
!
!    intent(c) C-type argument , array or function.
!
!    C expressions: rank, shape, len, size, slen.


!    -*- f90 -*-
! Note: the context of this file is case sensitive.
!
!subroutine euclidian_norm(a,c,n) ! in vector.f90
!    real(kind=8), dimension(n),intent(in) :: a
!    real(kind=8), intent(out) :: c
!    integer, optional,check(len(a)>=n),depend(a) :: n=len(a)
!
!end subroutine euclidian_norm
!
! This file was auto-generated with f2py (version:2).
! See http://cens.ioc.ee/projects/f2py2e/
end module input
