program main
  use nf, only: dense, input, network, sgd
  implicit none
  type(network) :: net
  real :: x(3), y(1)
  real, parameter :: pi = 4 * atan(1.)
  integer, parameter :: num_iterations = 100000
  integer, parameter :: test_size = 30
  integer, parameter :: n_data=7000
  integer :: i,ii, n
  real :: x_data_train(n_data,3), y_data_train(n_data)
  real :: x_test(n_data,3), y_test(n_data), y_pred(n_data)

  character(Len=528) :: path_in,path_out
  character(Len=528) :: filename_train,filename_test


  path_in='/cygdrive/d/paulo.kubota/pgmet/isabella/neural-fortran/example/isabella/datain'
  path_out='/cygdrive/d/paulo.kubota/pgmet/isabella/neural-fortran/example/isabella/datain'
  filename_train='datatrain.dat'
  filename_test='datatest.dat'

  OPEN(10,file=TRIM(path_in)//'/'//trim(filename_train),status='old',action='read',form='formatted') 
  read(10,'(1X)')
  do i=1, n_data
    read (10,*)x_data_train(i,1),x_data_train(i,2),x_data_train(i,3),y_data_train(i)
  end do
  
  print '("model training")'
  print '(60("="))'

  net = network([ &
                 input(3), &
                 dense(5), &
                 dense(1) &
                ])

  call net % print_info()
      

  x_test = x_data_train
  y_test = y_data_train

  do n = 1, n_data
     do i=1, n_data
        x(1) = x_data_train(i,1)/MAXVAL(x_data_train(:,1))
        x(2) = x_data_train(i,2)/MAXVAL(x_data_train(:,2))
        x(3) = x_data_train(i,3)/MAXVAL(x_data_train(:,3))
        y(1) = y_data_train(i)
        call net % forward(x)
        call net % backward(y)
     end do
        call net % update(optimizer=sgd(learning_rate=1.))

        !if (mod(n, 10000) == 0) then
        !  y_pred = [(net % predict([x_test(ii,:)]), ii = 1, n_data)]
        !  print '(i0,1x,3f9.6)', n, sum((y_pred - y_test)**2) / size(y_pred)
        !end if
  end do

stop
!  ypred = [(net % predict([xtest(i)]), i = 1, test_size)]
!  print '(i0,1x,3f9.6)', n, sum((ypred - ytest)**2) / size(ypred)
!
!  DO i=1,test_size
!    PRINT*,ytest(i), ypred(i)
!  END DO
end program main
