program main
  use nf, only:activation_function, dense, input, network, sgd,rmsprop
  use nf_activation, only: elu, leaky_relu,gaussian,sigmoid,tanhf
!  use nf_optimizers, only: sgd, rmsprop, adam, adagrad

  implicit none
  type(network) :: net
  real              :: xxx(1)
  real, allocatable :: x(:), y(:)
  real, allocatable :: xx(:), yy(:)
  integer, parameter :: num_iterations = 5
  integer :: n,i
  integer, parameter :: n_data=7000
  real :: x_data_train(n_data), y_data_train(n_data)
  real :: x_data_test(n_data), y_data_test(n_data), y_pred(n_data)

  character(Len=528) :: path_in,path_out
  character(Len=528) :: filename_train,filename_test
  real   , parameter :: learning_rate = 1.00
  integer, parameter :: num_epochs = 10
  real   , parameter :: momentum_value=0.9
  LOGICAL, parameter :: nesterov_value=.true. 
  real   , parameter :: decay_rate = 0.9

  path_in='/cygdrive/d/paulo.kubota/pgmet/isabella/neural-fortran/example/isabella/datain'
  path_out='/cygdrive/d/paulo.kubota/pgmet/isabella/neural-fortran/example/isabella/datain'
  filename_train='datatrain.dat'
  filename_test='datatest.dat'

  OPEN(10,file=TRIM(path_in)//'/'//trim(filename_train),status='old',action='read',form='formatted') 
  read(10,'(1X)')
  do i=1, n_data
    read (10,*)x_data_train(i),y_data_train(i)
  end do
  OPEN(20,file=TRIM(path_in)//'/'//trim(filename_test),status='old',action='read',form='formatted') 
  read(20,'(1X)')
  do i=1, n_data
    read (20,*)x_data_test(i),y_data_test(i)
  end do

  print '("Simple")'
  print '(60("="))'

  net = network([ &
    input(1), &
    dense(5, activation=sigmoid()), &
    dense(10, activation=sigmoid()), &
    dense(1, activation=sigmoid()) &
  ])

  call net % print_info()
  ALLOCATE(x(1),y(1))  
  ALLOCATE(xx(1),yy(1))  

  x=0
  do n = 1, num_epochs
     Do i=1,n_data
       call random_number(xxx)

       x(1)     = xxx(1)*x_data_train(i)
       y(1)     = y_data_train(i)

       call net % forward(x)
       call net % backward(y)
       call net % update(optimizer=sgd(learning_rate=learning_rate, &
                                       momentum=momentum_value, &
                                       nesterov=nesterov_value ))
     end do

!     call net % update( &
!        rmsprop(learning_rate=learning_rate, decay_rate=decay_rate) )
!
 
!
       !if (mod(n, 50) == 0) &
       !print '(i4,2(3x,2f12.6))', n, net % predict(x),y(1)

  end do

  do n = 1, n_data
     x(1) = x_data_test(n)
     y(1) = y_data_test(n)

     print '(i4,2(3x,3f12.6))', n, x(1), net % predict(x),y(1)

  end do
end program main
